import java.io.*;
import java.lang.Math;
import java.util.*;

// -----------------============== NOTE =============--------------------
// To make changes to "terminal" data (for grammars other than XQuery),
// go to the "Generator.java" file--that is the ONLY file that needs to
// be modified for those purposes; everything else is designed to run
// independently of the grammar being used.
// -----------------=================================--------------------

// ------------------------------
// -=-=-=- CharSetNode -=-=-=-
// ------------------------------

class CharSetNode extends GrammarNode {

    public CharSetNode(int lineNum, int colNum, String strVal) {

        myLineNum = lineNum;
        myColNum = colNum;
        myStrVal = strVal;
	myCharSet = "";

    } // end constructor.
 
    // ----

    public void unparse(PrintWriter p, int indent) {

        p.print(myStrVal);

    } // end method unparse.

    // ----

    public void createCharList() {

	// Get the char set.
	String str = toString();

	// Remove brackets.
	str = str.substring(1,str.length()-1);

	// Generate choices.
	char start = ' ';
	char end, curr;
	String choices = "";
	for (int i = 0; i < str.length(); i++) {

	    curr = str.charAt(i);
	    if (curr != '-') {
		choices += curr;
		start = curr;
	    } // end if.
	    else {
	    // we need to generate a range of valid characters.
		// Get last char in range.
		end = str.charAt(++i);
		if ((end == '-') || (end < start)) {
		    System.out.println("\n-=- ERROR: Invalid character" +
			" set: " + toString() + ". -=-\n");
		    return;
		} // end if.
		// else, generate all choices in range.
		curr = (char)(start + 1);
		while (curr <= end) {
		    choices += curr;
		    curr++;
		} // end while.
	    } // end else.

	} // end for.

	myCharSet = choices;

	return;
	
    } // end method createCharList.

    // ----

    public String toString() {

        return myStrVal;

    } // end method unparse.

    // ----

    public String charSet() {

        return myCharSet;

    } // end method unparse.

    // ----

    private int myLineNum;
    private int myColNum;
    private String myStrVal;
    private String myCharSet;

} // end class CharSetNode.
