import java.util.*;

class Constraint {

    // A constraint can only have ONE target: it is either a token
    // constraint, meaning the constraint is given as a token id (and the
    // type of the token with that id is used), OR it is a type constraint,
    // meaning that the type (string) is used directly.

    private Integer myVictim;		// Token being constrained.
    private Object myTarget;		// String or Integer.
    private boolean dynamic;		// Whether or not this is a dynamic
					//  constraint.

    public Constraint(Integer constrained, Object target, boolean dyn) {

	myVictim = constrained;
	myTarget = target;
	dynamic = dyn;

    } // end constructor.

    /* ==========================================================
     *
     * method victim():
     *
     * -------- */

    public int victim() {

	return myVictim.intValue();

    } // end method victim.

    /* ==========================================================
     *
     * method target():
     *
     * -------- */

    public String targetAsStr() {

	return myTarget.toString();

    } // end method target.

    /* ==========================================================
     *
     * method asToken():
     *
     * -------- */

    public int asToken() {

	return ((Integer)myTarget).intValue();

    } // end method asToken.

    // ----

    /* ==========================================================
     *
     * method asType():
     *
     * -------- */

    public String asType() {

	return (String)myTarget;

    } // end method asType.

    // ----

    /* ==========================================================
     *
     * method isDynamic():
     *
     * -------- */

    public boolean isDynamic() {

	return dynamic;

    } // end method isDynamic.

    // ----

    /* ==========================================================
     *
     * method toString():
     *
     * -------- */

    public String toString() {

	return (myVictim + "->" + myTarget);

    } // end method toString.

} // end class Constraint.
