import java.io.*;
import java.lang.Math;
import java.util.*;

// -----------------============== NOTE =============--------------------
// To make changes to "terminal" data (for grammars other than XQuery),
// go to the "Generator.java" file--that is the ONLY file that needs to
// be modified for those purposes; everything else is designed to run
// independently of the grammar being used.
// -----------------=================================--------------------

// ------------------------------
// -=-=-=-=-=- HeadNode -=-=-=-=-=-
// ------------------------------

class HeadNode extends GrammarNode {

/* Note that this "HeadNode" class had to be created to
 * avoid a shift/reduce conflict in gram.cup; don't know
 * why the conflict was showing up, but creating this
 * class and using "head" instead of "id DEFINE" seemed
 * to make things work... */

    public HeadNode(String strVal) {

	myStrVal = strVal;

    } // end constructor.

    // ----

    public void unparse(PrintWriter p, int indent) {

	p.print(myStrVal);
	p.print("  ");

    } // end method unparse.

    public void unparse() {
    // no params => 'silent', so we don't do anything.
    } // end unparse.

    // ----

    public String toString() {

	int tmp = myStrVal.indexOf("::=");
	return (myStrVal.substring(0,tmp)).trim();

    } // end method toString.

    // ----

    // 1 kid.
    private String myStrVal;

} // end class HeadNode.
