import java.io.*;
import java.lang.Math;
import java.util.*;

// -----------------============== NOTE =============--------------------
// To make changes to "terminal" data (for grammars other than XQuery),
// go to the "Generator.java" file--that is the ONLY file that needs to
// be modified for those purposes; everything else is designed to run
// independently of the grammar being used.
// -----------------=================================--------------------

// ------------------------------
// -=-=-=- RuleListNode -=-=-=-
// ------------------------------

class RuleListNode extends GrammarNode {

    public RuleListNode(Vector V) {

        myRules = V;

    } // end constructor.
 
    // ----

    public void unparse(PrintWriter p, int indent) {

	Iterator itr = myRules.iterator();
	while (itr.hasNext()) {
	    ((RuleNode)itr.next()).unparse(p,0);
	    p.println();
        } // end while.

    } // end method unparse.

    // ----

    public void sumUpSyntaxes() {

	Iterator itr = myRules.iterator();
	while (itr.hasNext()) {
	    ((RuleNode)itr.next()).sumUpSyntaxes();
        } // end while.

    } // end method sumUpSyntaxes.

    // ----

    public void createConfigFile(PrintWriter p) {

	Iterator itr = myRules.iterator();
	while (itr.hasNext()) {
	    ((RuleNode)itr.next()).createConfigFile(p);
        } // end while.

    } // end method createConfigFile.

    // ----

    // vector of kids (RuleNodes).
    private Vector myRules;

} // end class RuleListNode
