
// This file was automatically created by the RAGX generator.
//
// For a given string "ID_RECUR_X_Y," X is the syntax number within
// the rule that has ID as its head, and Y is the id of the occurence
// indicator within that syntax.
// Thus:
//              FAKE_SYNTAX_1
//              FAKE_RECUR_1_1
//              FAKE_RECUR_1_2
//              FAKE_SYNTAX_2
//              FAKE_RECUR_2_2
//
// describes a rule "Fake" that has 2 different syntaxes; of these
// syntaxes, the first has 2 occurence indicators, while the second
// only has one.  NOTE:  Occurrence indicators are numbered in the
// ORDER OF EVALUATION; thus, RECUR_1_1 refers to the indicator that
// will be evaluated first, RECUR_1_2 to the one that will be
// evaluated second, etc.
//
// For rules with more than one syntax choice, the final parameter is
// a 'termination syntax' parameter that ends with the word 'ENDING'
// (for exampe, FAKE_ENDING).  This parameter is for those cases where
// query generation results in Stack Overflow; it is used to specify
// which syntax of a given rule should be chosen when the generator
// has reached its maximum depth (a limit that is also set in this
// file, presumably so that it is reached before stack overflow).
//
// The termination syntax should, in theory, be whatever choice leads
// to the nearest terminal, though this is in NO WAY checked by the
// generator (it is up to the person who modifies this file to make
// the appropriate termination syntax choices).  The default termination
// choice is '-1', which is a value that is ignored by the generator.
// For rules where the choice of syntax doesn't matter, the termination
// syntax should be set to '0'.


MAX_DEPTH	20
SEED		0


QUERYPROLOG_SYNTAX_1                         1  	//  (NamespaceDecl )* FunctionDefn* 
QUERYPROLOG_RECUR_1_1                        0  	//  --
QUERYPROLOG_RECUR_1_1_MAX                    0  	//  --
QUERYPROLOG_RECUR_1_2                        0  	//  --
QUERYPROLOG_RECUR_1_2_MAX                    0  	//  --
QUERYPROLOG_SYNTAX_2                         0  	//  (XMLSpaceDecl )* FunctionDefn* 
QUERYPROLOG_RECUR_2_1                        0  	//  --
QUERYPROLOG_RECUR_2_1_MAX                    1  	//  --
QUERYPROLOG_RECUR_2_2                        0  	//  --
QUERYPROLOG_RECUR_2_2_MAX                    1  	//  --
QUERYPROLOG_SYNTAX_3                         0  	//  (DefaultNamespaceDecl )* FunctionDefn* 
QUERYPROLOG_RECUR_3_1                        0  	//  --
QUERYPROLOG_RECUR_3_1_MAX                    1  	//  --
QUERYPROLOG_RECUR_3_2                        0  	//  --
QUERYPROLOG_RECUR_3_2_MAX                    1  	//  --
QUERYPROLOG_SYNTAX_4                         0  	//  (DefaultCollationDecl )* FunctionDefn* 
QUERYPROLOG_RECUR_4_1                        0  	//  --
QUERYPROLOG_RECUR_4_1_MAX                    1  	//  --
QUERYPROLOG_RECUR_4_2                        0  	//  --
QUERYPROLOG_RECUR_4_2_MAX                    1  	//  --
QUERYPROLOG_SYNTAX_5                         0  	//  (SchemaImport )* FunctionDefn* 
QUERYPROLOG_RECUR_5_1                        0  	//  --
QUERYPROLOG_RECUR_5_1_MAX                    1  	//  --
QUERYPROLOG_RECUR_5_2                        0  	//  --
QUERYPROLOG_RECUR_5_2_MAX                    1  	//  --
QUERYPROLOG_ENDING                           0  	// ===> Termination Syntax.

QUERYBODY_SYNTAX_1                           1  	//  ExprSequence? 
QUERYBODY_RECUR_1_1                          1  	//  --

EXPRSEQUENCE_SYNTAX_1                        1  	//  Expr ("," Expr )* 
EXPRSEQUENCE_RECUR_1_1                       0.5  	//  --
EXPRSEQUENCE_RECUR_1_1_MAX                   1  	//  --

OREXPR_SYNTAX_1                              1  	//  AndExpr ("or" AndExpr )* 
OREXPR_RECUR_1_1                             0.5  	//  --
OREXPR_RECUR_1_1_MAX                         1  	//  --

ANDEXPR_SYNTAX_1                             1  	//  FLWRExpr ("and" FLWRExpr )* 
ANDEXPR_RECUR_1_1                            0.5  	//  --
ANDEXPR_RECUR_1_1_MAX                        1  	//  --

FLWREXPR_SYNTAX_1                            1  	//  ((ForClause )+ WhereClause? OrderByClause? "return" )* QuantifiedExpr 
FLWREXPR_RECUR_1_1                           0.1  	//  --
FLWREXPR_RECUR_1_1_MAX                       1  	//  --
FLWREXPR_RECUR_1_2                           0.1  	//  --
FLWREXPR_RECUR_1_2_MAX                       1  	//  --
FLWREXPR_RECUR_1_3                           0.5  	//  --
FLWREXPR_RECUR_1_4                           0.5  	//  --
FLWREXPR_SYNTAX_2                            1  	//  ((LetClause )+ WhereClause? OrderByClause? "return" )* QuantifiedExpr 
FLWREXPR_RECUR_2_1                           0.1  	//  --
FLWREXPR_RECUR_2_1_MAX                       1  	//  --
FLWREXPR_RECUR_2_2                           0.1  	//  --
FLWREXPR_RECUR_2_2_MAX                       1  	//  --
FLWREXPR_RECUR_2_3                           0.5  	//  --
FLWREXPR_RECUR_2_4                           0.5  	//  --
FLWREXPR_ENDING                              0  	// ===> Termination Syntax.

QUANTIFIEDEXPR_SYNTAX_1                      1  	//  ("some" "$" VarName TypeDeclaration? "in" Expr ("," "$" VarName TypeDeclaration? "in" Expr )* "satisfies" )* TypeswitchExpr 
QUANTIFIEDEXPR_RECUR_1_1                     0.15  	//  --
QUANTIFIEDEXPR_RECUR_1_1_MAX                 1  	//  --
QUANTIFIEDEXPR_RECUR_1_2                     0.5  	//  --
QUANTIFIEDEXPR_RECUR_1_3                     0.5  	//  --
QUANTIFIEDEXPR_RECUR_1_3_MAX                 1  	//  --
QUANTIFIEDEXPR_RECUR_1_4                     0.5  	//  --
QUANTIFIEDEXPR_SYNTAX_2                      1  	//  ("every" "$" VarName TypeDeclaration? "in" Expr ("," "$" VarName TypeDeclaration? "in" Expr )* "satisfies" )* TypeswitchExpr 
QUANTIFIEDEXPR_RECUR_2_1                     0.15  	//  --
QUANTIFIEDEXPR_RECUR_2_1_MAX                 1  	//  --
QUANTIFIEDEXPR_RECUR_2_2                     0.5  	//  --
QUANTIFIEDEXPR_RECUR_2_3                     0.5  	//  --
QUANTIFIEDEXPR_RECUR_2_3_MAX                 1  	//  --
QUANTIFIEDEXPR_RECUR_2_4                     0.5  	//  --
QUANTIFIEDEXPR_ENDING                        0  	// ===> Termination Syntax.

TYPESWITCHEXPR_SYNTAX_1                      1  	//  ("typeswitch" "(" Expr ")" CaseClause+ "default" ("$" VarName )? "return" )* IfExpr 
TYPESWITCHEXPR_RECUR_1_1                     0.0  	//  --
TYPESWITCHEXPR_RECUR_1_1_MAX                 1  	//  --
TYPESWITCHEXPR_RECUR_1_2                     0.5  	//  --
TYPESWITCHEXPR_RECUR_1_2_MAX                 1  	//  --
TYPESWITCHEXPR_RECUR_1_3                     0.5  	//  --

IFEXPR_SYNTAX_1                              1  	//  ("if" "(" Expr ")" "then" Expr "else" )* InstanceofExpr 
IFEXPR_RECUR_1_1                             0.15  	//  --
IFEXPR_RECUR_1_1_MAX                         1  	//  --

INSTANCEOFEXPR_SYNTAX_1                      1  	//  CastableExpr ("instance" "of" SequenceType )? 
INSTANCEOFEXPR_RECUR_1_1                     0.15  	//  --

CASTABLEEXPR_SYNTAX_1                        1  	//  ComparisonExpr ("castable" "as" SingleType )? 
CASTABLEEXPR_RECUR_1_1                       0.15  	//  --

COMPARISONEXPR_SYNTAX_1                      1  	//  RangeExpr (ValueComp RangeExpr )? 
COMPARISONEXPR_RECUR_1_1                     0.5  	//  --
COMPARISONEXPR_SYNTAX_2                      1  	//  RangeExpr (GeneralComp RangeExpr )? 
COMPARISONEXPR_RECUR_2_1                     0.5  	//  --
COMPARISONEXPR_SYNTAX_3                      1  	//  RangeExpr (NodeComp RangeExpr )? 
COMPARISONEXPR_RECUR_3_1                     0.5  	//  --
COMPARISONEXPR_SYNTAX_4                      1  	//  RangeExpr (OrderComp RangeExpr )? 
COMPARISONEXPR_RECUR_4_1                     0.5  	//  --
COMPARISONEXPR_ENDING                        0  	// ===> Termination Syntax.

RANGEEXPR_SYNTAX_1                           1  	//  AdditiveExpr ("to" AdditiveExpr )? 
RANGEEXPR_RECUR_1_1                          0.15  	//  --

ADDITIVEEXPR_SYNTAX_1                        1  	//  MultiplicativeExpr ("+" MultiplicativeExpr )* 
ADDITIVEEXPR_RECUR_1_1                       0.5  	//  --
ADDITIVEEXPR_RECUR_1_1_MAX                   1  	//  --
ADDITIVEEXPR_SYNTAX_2                        1  	//  MultiplicativeExpr ("-" MultiplicativeExpr )* 
ADDITIVEEXPR_RECUR_2_1                       0.5  	//  --
ADDITIVEEXPR_RECUR_2_1_MAX                   1  	//  --
ADDITIVEEXPR_ENDING                          0  	// ===> Termination Syntax.

MULTIPLICATIVEEXPR_SYNTAX_1                  1  	//  UnaryExpr ("*" UnaryExpr )* 
MULTIPLICATIVEEXPR_RECUR_1_1                 0.5  	//  --
MULTIPLICATIVEEXPR_RECUR_1_1_MAX             1  	//  --
MULTIPLICATIVEEXPR_SYNTAX_2                  1  	//  UnaryExpr ("div" UnaryExpr )* 
MULTIPLICATIVEEXPR_RECUR_2_1                 0.5  	//  --
MULTIPLICATIVEEXPR_RECUR_2_1_MAX             1  	//  --
MULTIPLICATIVEEXPR_SYNTAX_3                  1  	//  UnaryExpr ("idiv" UnaryExpr )* 
MULTIPLICATIVEEXPR_RECUR_3_1                 0.5  	//  --
MULTIPLICATIVEEXPR_RECUR_3_1_MAX             1  	//  --
MULTIPLICATIVEEXPR_SYNTAX_4                  1  	//  UnaryExpr ("mod" UnaryExpr )* 
MULTIPLICATIVEEXPR_RECUR_4_1                 0.5  	//  --
MULTIPLICATIVEEXPR_RECUR_4_1_MAX             1  	//  --
MULTIPLICATIVEEXPR_ENDING                    0  	// ===> Termination Syntax.

UNARYEXPR_SYNTAX_1                           1  	//  ("-" )* UnionExpr 
UNARYEXPR_RECUR_1_1                          0.10  	//  --
UNARYEXPR_RECUR_1_1_MAX                      1  	//  --
UNARYEXPR_SYNTAX_2                           1  	//  ("+" )* UnionExpr 
UNARYEXPR_RECUR_2_1                          0.10  	//  --
UNARYEXPR_RECUR_2_1_MAX                      1  	//  --
UNARYEXPR_ENDING                             0  	// ===> Termination Syntax.

UNIONEXPR_SYNTAX_1                           1  	//  IntersectExceptExpr ("union" IntersectExceptExpr )* 
UNIONEXPR_RECUR_1_1                          0.15  	//  --
UNIONEXPR_RECUR_1_1_MAX                      1  	//  --
UNIONEXPR_SYNTAX_2                           1  	//  IntersectExceptExpr ("|" IntersectExceptExpr )* 
UNIONEXPR_RECUR_2_1                          0.15  	//  --
UNIONEXPR_RECUR_2_1_MAX                      1  	//  --
UNIONEXPR_ENDING                             0  	// ===> Termination Syntax.

INTERSECTEXCEPTEXPR_SYNTAX_1                 1  	//  ValueExpr ("intersect" ValueExpr )* 
INTERSECTEXCEPTEXPR_RECUR_1_1                0.15  	//  --
INTERSECTEXCEPTEXPR_RECUR_1_1_MAX            1  	//  --
INTERSECTEXCEPTEXPR_SYNTAX_2                 1  	//  ValueExpr ("except" ValueExpr )* 
INTERSECTEXCEPTEXPR_RECUR_2_1                0.15  	//  --
INTERSECTEXCEPTEXPR_RECUR_2_1_MAX            1  	//  --
INTERSECTEXCEPTEXPR_ENDING                   0  	// ===> Termination Syntax.

VALUEEXPR_SYNTAX_1                           0  	//  ValidateExpr 
VALUEEXPR_SYNTAX_2                           0  	//  CastExpr 
VALUEEXPR_SYNTAX_3                           0  	//  TreatExpr 
VALUEEXPR_SYNTAX_4                           0  	//  Constructor 
VALUEEXPR_SYNTAX_5                           1  	//  PathExpr 
VALUEEXPR_ENDING                             5  	// ===> Termination Syntax.

PATHEXPR_SYNTAX_1                            1  	//  ("/" RelativePathExpr? ) 
PATHEXPR_RECUR_1_1                           0.75  	//  --
PATHEXPR_SYNTAX_2                            1  	//  ("//" RelativePathExpr ) 
PATHEXPR_SYNTAX_3                            1  	//  RelativePathExpr 
PATHEXPR_ENDING                              1  	// ===> Termination Syntax.

RELATIVEPATHEXPR_SYNTAX_1                    1  	//  StepExpr ("/" StepExpr )* 
RELATIVEPATHEXPR_RECUR_1_1                   0.75  	//  --
RELATIVEPATHEXPR_RECUR_1_1_MAX               1  	//  --
RELATIVEPATHEXPR_SYNTAX_2                    1  	//  StepExpr ("//" StepExpr )* 
RELATIVEPATHEXPR_RECUR_2_1                   0.75  	//  --
RELATIVEPATHEXPR_RECUR_2_1_MAX               1  	//  --
RELATIVEPATHEXPR_ENDING                      0  	// ===> Termination Syntax.

STEPEXPR_SYNTAX_1                            1  	//  ForwardStep Predicates 
STEPEXPR_SYNTAX_2                            1  	//  ReverseStep Predicates 
STEPEXPR_SYNTAX_3                            1  	//  PrimaryExpr Predicates 
STEPEXPR_ENDING                              3  	// ===> Termination Syntax.

FORCLAUSE_SYNTAX_1                           1  	//  "for" "$" VarName TypeDeclaration? PositionalVar? "in" Expr ("," "$" VarName TypeDeclaration? PositionalVar? "in" Expr )* 
FORCLAUSE_RECUR_1_1                          0.5  	//  --
FORCLAUSE_RECUR_1_2                          0.5  	//  --
FORCLAUSE_RECUR_1_3                          0.15  	//  --
FORCLAUSE_RECUR_1_3_MAX                      1  	//  --
FORCLAUSE_RECUR_1_4                          0.5  	//  --
FORCLAUSE_RECUR_1_5                          0.5  	//  --

LETCLAUSE_SYNTAX_1                           1  	//  "let" "$" VarName TypeDeclaration? ":=" Expr ("," "$" VarName TypeDeclaration? ":=" Expr )* 
LETCLAUSE_RECUR_1_1                          0.5  	//  --
LETCLAUSE_RECUR_1_2                          0.15  	//  --
LETCLAUSE_RECUR_1_2_MAX                      1  	//  --
LETCLAUSE_RECUR_1_3                          0.5  	//  --

VALIDATEEXPR_SYNTAX_1                        3  	//  "validate" "{" Expr "}" 
VALIDATEEXPR_SYNTAX_2                        1  	//  ("validate" "context" SchemaGlobalContext ("/" SchemaContextStep )* "{" ) Expr "}" 
VALIDATEEXPR_RECUR_2_1                       0.5  	//  --
VALIDATEEXPR_RECUR_2_1_MAX                   1  	//  --
VALIDATEEXPR_ENDING                          1  	// ===> Termination Syntax.

CONSTRUCTOR_SYNTAX_1                         1  	//  ElementConstructor 
CONSTRUCTOR_SYNTAX_2                         3  	//  XmlComment 
CONSTRUCTOR_SYNTAX_3                         3  	//  XmlProcessingInstruction 
CONSTRUCTOR_SYNTAX_4                         3  	//  CdataSection 
CONSTRUCTOR_SYNTAX_5                         1  	//  ComputedDocumentConstructor 
CONSTRUCTOR_SYNTAX_6                         1  	//  ComputedElementConstructor 
CONSTRUCTOR_SYNTAX_7                         1  	//  ComputedAttributeConstructor 
CONSTRUCTOR_SYNTAX_8                         1  	//  ComputedTextConstructor 
CONSTRUCTOR_ENDING                           4  	// ===> Termination Syntax.

GENERALCOMP_SYNTAX_1                         1  	//  "=" 
GENERALCOMP_SYNTAX_2                         1  	//  "!=" 
GENERALCOMP_SYNTAX_3                         1  	//  "<" 
GENERALCOMP_SYNTAX_4                         1  	//  "<=" 
GENERALCOMP_SYNTAX_5                         1  	//  ">" 
GENERALCOMP_SYNTAX_6                         1  	//  ">=" 
GENERALCOMP_ENDING                           0  	// ===> Termination Syntax.

VALUECOMP_SYNTAX_1                           1  	//  "eq" 
VALUECOMP_SYNTAX_2                           1  	//  "ne" 
VALUECOMP_SYNTAX_3                           1  	//  "lt" 
VALUECOMP_SYNTAX_4                           1  	//  "le" 
VALUECOMP_SYNTAX_5                           1  	//  "gt" 
VALUECOMP_SYNTAX_6                           1  	//  "ge" 
VALUECOMP_ENDING                             0  	// ===> Termination Syntax.

NODECOMP_SYNTAX_1                            1  	//  "is" 
NODECOMP_SYNTAX_2                            1  	//  "isnot" 
NODECOMP_ENDING                              0  	// ===> Termination Syntax.

ORDERCOMP_SYNTAX_1                           1  	//  "<<" 
ORDERCOMP_SYNTAX_2                           1  	//  ">>" 
ORDERCOMP_ENDING                             0  	// ===> Termination Syntax.

ORDERBYCLAUSE_SYNTAX_1                       1  	//  "order" "by" OrderSpecList 
ORDERBYCLAUSE_SYNTAX_2                       1  	//  "stable" "order" "by" OrderSpecList 
ORDERBYCLAUSE_ENDING                         0  	// ===> Termination Syntax.

ORDERSPECLIST_SYNTAX_1                       1  	//  OrderSpec ("," OrderSpec )* 
ORDERSPECLIST_RECUR_1_1                      0.5  	//  --
ORDERSPECLIST_RECUR_1_1_MAX                  1  	//  --

ORDERMODIFIER_SYNTAX_1                       1  	//  ("ascending" )? ("empty" "greatest" )? ("collation" StringLiteral )? 
ORDERMODIFIER_RECUR_1_1                      0.5  	//  --
ORDERMODIFIER_RECUR_1_2                      0.5  	//  --
ORDERMODIFIER_RECUR_1_3                      0.5  	//  --
ORDERMODIFIER_SYNTAX_2                       1  	//  ("ascending" )? ("empty" "least" )? ("collation" StringLiteral )? 
ORDERMODIFIER_RECUR_2_1                      0.5  	//  --
ORDERMODIFIER_RECUR_2_2                      0.5  	//  --
ORDERMODIFIER_RECUR_2_3                      0.5  	//  --
ORDERMODIFIER_SYNTAX_3                       1  	//  ("descending" )? ("empty" "greatest" )? ("collation" StringLiteral )? 
ORDERMODIFIER_RECUR_3_1                      0.5  	//  --
ORDERMODIFIER_RECUR_3_2                      0.5  	//  --
ORDERMODIFIER_RECUR_3_3                      0.5  	//  --
ORDERMODIFIER_SYNTAX_4                       1  	//  ("descending" )? ("empty" "least" )? ("collation" StringLiteral )? 
ORDERMODIFIER_RECUR_4_1                      0.5  	//  --
ORDERMODIFIER_RECUR_4_2                      0.5  	//  --
ORDERMODIFIER_RECUR_4_3                      0.5  	//  --
ORDERMODIFIER_ENDING                         0  	// ===> Termination Syntax.

CASECLAUSE_SYNTAX_1                          1  	//  "case" ("$" VarName "as" )? SequenceType "return" Expr 
CASECLAUSE_RECUR_1_1                         0.5  	//  --

PRIMARYEXPR_SYNTAX_1                         3  	//  Literal 
PRIMARYEXPR_SYNTAX_2                         0  	//  FunctionCall 
PRIMARYEXPR_SYNTAX_3                         1  	//  ("$" VarName ) 
PRIMARYEXPR_SYNTAX_4                         1  	//  ParenthesizedExpr 
PRIMARYEXPR_ENDING                           1  	// ===> Termination Syntax.

FORWARDAXIS_SYNTAX_1                         1  	//  "child" "::" 
FORWARDAXIS_SYNTAX_2                         1  	//  "descendant" "::" 
FORWARDAXIS_SYNTAX_3                         1  	//  "attribute" "::" 
FORWARDAXIS_SYNTAX_4                         1  	//  "self" "::" 
FORWARDAXIS_SYNTAX_5                         1  	//  "descendant-or-self" "::" 
FORWARDAXIS_ENDING                           0  	// ===> Termination Syntax.

NODETEST_SYNTAX_1                            1  	//  KindTest 
NODETEST_SYNTAX_2                            1  	//  NameTest 
NODETEST_ENDING                              0  	// ===> Termination Syntax.

NAMETEST_SYNTAX_1                            1  	//  QName 
NAMETEST_SYNTAX_2                            1  	//  Wildcard 
NAMETEST_ENDING                              1  	// ===> Termination Syntax.

WILDCARD_SYNTAX_1                            1  	//  "*" 
WILDCARD_SYNTAX_2                            1  	//  NCName ":" "*" 
WILDCARD_SYNTAX_3                            1  	//  "*" ":" NCName 
WILDCARD_SYNTAX_4			     1		// AttributeName
WILDCARD_ENDING                              0  	// ===> Termination Syntax.

KINDTEST_SYNTAX_1                            1  	//  ProcessingInstructionTest 
KINDTEST_SYNTAX_2                            1  	//  CommentTest 
KINDTEST_SYNTAX_3                            1  	//  TextTest 
KINDTEST_SYNTAX_4                            1  	//  AnyKindTest 
KINDTEST_ENDING                              0  	// ===> Termination Syntax.

PROCESSINGINSTRUCTIONTEST_SYNTAX_1           1  	//  "processing-instruction" "(" StringLiteral? ")" 
PROCESSINGINSTRUCTIONTEST_RECUR_1_1          0.5  	//  --

FORWARDSTEP_SYNTAX_1                         2  	//  (ForwardAxis NodeTest ) 
FORWARDSTEP_SYNTAX_2                         1  	//  AbbreviatedForwardStep 
FORWARDSTEP_ENDING                           2  	// ===> Termination Syntax.

REVERSESTEP_SYNTAX_1                         1  	//  (ReverseAxis NodeTest ) 
REVERSESTEP_SYNTAX_2                         1  	//  AbbreviatedReverseStep 
REVERSESTEP_ENDING                           2  	// ===> Termination Syntax.

ABBREVIATEDFORWARDSTEP_SYNTAX_1              1  	//  "." 
ABBREVIATEDFORWARDSTEP_SYNTAX_2              1  	//  ("@" NameTest ) 
ABBREVIATEDFORWARDSTEP_SYNTAX_3              1  	//  NodeTest 
ABBREVIATEDFORWARDSTEP_ENDING                0  	// ===> Termination Syntax.

PREDICATES_SYNTAX_1                          1  	//  ("[" Expr "]" )* 
PREDICATES_RECUR_1_1                         0.5  	//  --
PREDICATES_RECUR_1_1_MAX                     1  	//  --

NUMERICLITERAL_SYNTAX_1                      1  	//  IntegerLiteral 
NUMERICLITERAL_SYNTAX_2                      1  	//  DecimalLiteral 
NUMERICLITERAL_SYNTAX_3                      1  	//  DoubleLiteral 
NUMERICLITERAL_ENDING                        0  	// ===> Termination Syntax.

LITERAL_SYNTAX_1                             1  	//  NumericLiteral 
LITERAL_SYNTAX_2                             1  	//  StringLiteral 
LITERAL_ENDING                               0  	// ===> Termination Syntax.

PARENTHESIZEDEXPR_SYNTAX_1                   1  	//  "(" ExprSequence? ")" 
PARENTHESIZEDEXPR_RECUR_1_1                  0.5  	//  --

FUNCTIONCALL_SYNTAX_1                        1  	//  QName "(" (Expr ("," Expr )* )? ")" 
FUNCTIONCALL_RECUR_1_1                       0.5  	//  --
FUNCTIONCALL_RECUR_1_2                       0.5  	//  --
FUNCTIONCALL_RECUR_1_2_MAX                   1  	//  --

PARAM_SYNTAX_1                               1  	//  "$" VarName TypeDeclaration? 
PARAM_RECUR_1_1                              0.5  	//  --

SCHEMACONTEXT_SYNTAX_1                       1  	//  "context" SchemaGlobalContext ("/" SchemaContextStep )* 
SCHEMACONTEXT_RECUR_1_1                      0.5  	//  --
SCHEMACONTEXT_RECUR_1_1_MAX                  1  	//  --

SCHEMAGLOBALCONTEXT_SYNTAX_1                 1  	//  QName 
SCHEMAGLOBALCONTEXT_SYNTAX_2                 1  	//  "type" QName 
SCHEMAGLOBALCONTEXT_ENDING                   1  	// ===> Termination Syntax.

SINGLETYPE_SYNTAX_1                          1  	//  AtomicType "?"? 
SINGLETYPE_RECUR_1_1                         0.5  	//  --

SEQUENCETYPE_SYNTAX_1                        1  	//  (ItemType OccurrenceIndicator ) 
SEQUENCETYPE_SYNTAX_2                        1  	//  "empty" 
SEQUENCETYPE_ENDING                          2  	// ===> Termination Syntax.

ITEMTYPE_SYNTAX_1                            1  	//  "element" ElemOrAttrType? 
ITEMTYPE_RECUR_1_1                           0.5  	//  --
ITEMTYPE_SYNTAX_2                            1  	//  "attribute" ElemOrAttrType? 
ITEMTYPE_RECUR_2_1                           0.5  	//  --
ITEMTYPE_SYNTAX_3                            1  	//  "node" 
ITEMTYPE_SYNTAX_4                            1  	//  "processing-instruction" 
ITEMTYPE_SYNTAX_5                            1  	//  "comment" 
ITEMTYPE_SYNTAX_6                            1  	//  "text" 
ITEMTYPE_SYNTAX_7                            1  	//  "document" 
ITEMTYPE_SYNTAX_8                            1  	//  "item" 
ITEMTYPE_SYNTAX_9                            1  	//  AtomicType 
ITEMTYPE_SYNTAX_10                           1  	//  "untyped" 
ITEMTYPE_SYNTAX_11                           1  	//  "atomic" "value" 
ITEMTYPE_ENDING                              0  	// ===> Termination Syntax.

ELEMORATTRTYPE_SYNTAX_1                      1  	//  QName SchemaType 
ELEMORATTRTYPE_SYNTAX_2                      1  	//  QName SchemaContext? 
ELEMORATTRTYPE_RECUR_2_1                     0.5  	//  --
ELEMORATTRTYPE_SYNTAX_3                      1  	//  SchemaType 
ELEMORATTRTYPE_ENDING                        1  	// ===> Termination Syntax.

OCCURRENCEINDICATOR_SYNTAX_1                 1  	//  ("*" )? 
OCCURRENCEINDICATOR_RECUR_1_1                0.25  	//  --
OCCURRENCEINDICATOR_SYNTAX_2                 1  	//  ("+" )? 
OCCURRENCEINDICATOR_RECUR_2_1                0.25  	//  --
OCCURRENCEINDICATOR_SYNTAX_3                 1  	//  ("?" )? 
OCCURRENCEINDICATOR_RECUR_3_1                0.25  	//  --
OCCURRENCEINDICATOR_ENDING                   0  	// ===> Termination Syntax.

ELEMENTCONSTRUCTOR_SYNTAX_1                  1  	//  "<" QName AttributeList "/>" 
ELEMENTCONSTRUCTOR_SYNTAX_2                  1  	//  "<" QName AttributeList (">" ElementContent* "</" QName S? ">" ) 
ELEMENTCONSTRUCTOR_RECUR_2_1                 0.5  	//  --
ELEMENTCONSTRUCTOR_RECUR_2_1_MAX             1  	//  --
ELEMENTCONSTRUCTOR_RECUR_2_2                 0.5  	//  --
ELEMENTCONSTRUCTOR_ENDING                    1  	// ===> Termination Syntax.

COMPUTEDELEMENTCONSTRUCTOR_SYNTAX_1          1  	//  "element" QName "{" ExprSequence? "}" 
COMPUTEDELEMENTCONSTRUCTOR_RECUR_1_1         0.5  	//  --
COMPUTEDELEMENTCONSTRUCTOR_SYNTAX_2          1  	//  ("element" "{" Expr "}" "{" ) ExprSequence? "}" 
COMPUTEDELEMENTCONSTRUCTOR_RECUR_2_1         0.5  	//  --
COMPUTEDELEMENTCONSTRUCTOR_ENDING            1  	// ===> Termination Syntax.

COMPUTEDATTRIBUTECONSTRUCTOR_SYNTAX_1        1  	//  "attribute" QName "{" ExprSequence? "}" 
COMPUTEDATTRIBUTECONSTRUCTOR_RECUR_1_1       0.5  	//  --
COMPUTEDATTRIBUTECONSTRUCTOR_SYNTAX_2        1  	//  ("attribute" "{" Expr "}" "{" ) ExprSequence? "}" 
COMPUTEDATTRIBUTECONSTRUCTOR_RECUR_2_1       0.5  	//  --
COMPUTEDATTRIBUTECONSTRUCTOR_ENDING          1  	// ===> Termination Syntax.

COMPUTEDTEXTCONSTRUCTOR_SYNTAX_1             1  	//  "text" "{" ExprSequence? "}" 
COMPUTEDTEXTCONSTRUCTOR_RECUR_1_1            0.5  	//  --

CDATASECTION_SYNTAX_1                        1  	// "<![CDATA[" Cdata "]]>" 
CDATASECTION_RECUR_1_1                       0.5  	//  --
CDATASECTION_RECUR_1_1_MAX                   1  	//  --

XMLPROCESSINGINSTRUCTION_SYNTAX_1            1  	//  "<?" PITarget Cdata "?>" 
XMLPROCESSINGINSTRUCTION_RECUR_1_1           0.5  	//  --
XMLPROCESSINGINSTRUCTION_RECUR_1_1_MAX       1  	//  --

XMLCOMMENT_SYNTAX_1                          1  	//  "<!--" Cdata "-->" 
XMLCOMMENT_RECUR_1_1                         0.5  	//  --
XMLCOMMENT_RECUR_1_1_MAX                     1  	//  --

ELEMENTCONTENT_SYNTAX_1                      1  	//  Char 
ELEMENTCONTENT_SYNTAX_2                      1  	//  "{{" 
ELEMENTCONTENT_SYNTAX_3                      1  	//  "}}" 
ELEMENTCONTENT_SYNTAX_4                      1  	//  ElementConstructor 
ELEMENTCONTENT_SYNTAX_5                      1  	//  EnclosedExpr 
ELEMENTCONTENT_SYNTAX_6                      1  	//  CdataSection 
ELEMENTCONTENT_SYNTAX_7                      1  	//  CharRef 
ELEMENTCONTENT_SYNTAX_8                      1  	//  PredefinedEntityRef 
ELEMENTCONTENT_SYNTAX_9                      1  	//  XmlComment 
ELEMENTCONTENT_SYNTAX_10                     1  	//  XmlProcessingInstruction 
ELEMENTCONTENT_ENDING                        11  	// ===> Termination Syntax.

ATTRIBUTELIST_SYNTAX_1                       1  	//  (S (QName S? "=" S? AttributeValue )? )* 
ATTRIBUTELIST_RECUR_1_1                      0.5  	//  --
ATTRIBUTELIST_RECUR_1_1_MAX                  1  	//  --
ATTRIBUTELIST_RECUR_1_2                      0.5  	//  --
ATTRIBUTELIST_RECUR_1_3                      0.5  	//  --
ATTRIBUTELIST_RECUR_1_4                      0.5  	//  --

ATTRIBUTEVALUE_SYNTAX_1                      1  	//  """ (EscapeQuot )* """ 
ATTRIBUTEVALUE_RECUR_1_1                     0.5  	//  --
ATTRIBUTEVALUE_RECUR_1_1_MAX                 1  	//  --
ATTRIBUTEVALUE_SYNTAX_2                      1  	//  """ (AttributeValueContent )* """ 
ATTRIBUTEVALUE_RECUR_2_1                     0.5  	//  --
ATTRIBUTEVALUE_RECUR_2_1_MAX                 1  	//  --
ATTRIBUTEVALUE_SYNTAX_3                      1  	//  "'" (EscapeApos )* "'" 
ATTRIBUTEVALUE_RECUR_3_1                     0.5  	//  --
ATTRIBUTEVALUE_RECUR_3_1_MAX                 1  	//  --
ATTRIBUTEVALUE_SYNTAX_4                      1  	//  "'" (AttributeValueContent )* "'" 
ATTRIBUTEVALUE_RECUR_4_1                     0.5  	//  --
ATTRIBUTEVALUE_RECUR_4_1_MAX                 1  	//  --
ATTRIBUTEVALUE_ENDING                        0  	// ===> Termination Syntax.

ATTRIBUTEVALUECONTENT_SYNTAX_1               1  	//  Char 
ATTRIBUTEVALUECONTENT_SYNTAX_2               1  	//  CharRef 
ATTRIBUTEVALUECONTENT_SYNTAX_3               1  	//  "{{" 
ATTRIBUTEVALUECONTENT_SYNTAX_4               1  	//  "}}" 
ATTRIBUTEVALUECONTENT_SYNTAX_5               1  	//  EnclosedExpr 
ATTRIBUTEVALUECONTENT_SYNTAX_6               1  	//  PredefinedEntityRef 
ATTRIBUTEVALUECONTENT_ENDING                 1  	// ===> Termination Syntax.

XMLSPACEDECL_SYNTAX_1                        1  	//  "declare" "xmlspace" "=" "preserve" 
XMLSPACEDECL_SYNTAX_2                        1  	//  "declare" "xmlspace" "=" "strip" 
XMLSPACEDECL_ENDING                          1  	// ===> Termination Syntax.

DEFAULTNAMESPACEDECL_SYNTAX_1                1  	//  "default" "element" "namespace" "=" URLLiteral 
DEFAULTNAMESPACEDECL_SYNTAX_2                1  	//  "default" "function" "namespace" "=" URLLiteral 
DEFAULTNAMESPACEDECL_ENDING                  1  	// ===> Termination Syntax.

FUNCTIONDEFN_SYNTAX_1                        1  	//  "define" "function" QName "(" ParamList? ")" EnclosedExpr 
FUNCTIONDEFN_RECUR_1_1                       0.5  	//  --
FUNCTIONDEFN_SYNTAX_2                        1  	//  "define" "function" QName "(" ParamList? (")" "as" SequenceType ) EnclosedExpr 
FUNCTIONDEFN_RECUR_2_1                       0.5  	//  --
FUNCTIONDEFN_ENDING                          1  	// ===> Termination Syntax.

PARAMLIST_SYNTAX_1                           1  	//  Param ("," Param )* 
PARAMLIST_RECUR_1_1                          0.5  	//  --
PARAMLIST_RECUR_1_1_MAX                      1  	//  --

SCHEMAIMPORT_SYNTAX_1                        1  	//  "import" "schema" StringLiteral "at" StringLiteral? 
SCHEMAIMPORT_RECUR_1_1                       0.5  	//  --
SCHEMAIMPORT_SYNTAX_2                        1  	//  "import" "schema" SubNamespaceDecl "at" StringLiteral? 
SCHEMAIMPORT_RECUR_2_1                       0.5  	//  --
SCHEMAIMPORT_SYNTAX_3                        1  	//  "import" "schema" DefaultNamespaceDecl "at" StringLiteral? 
SCHEMAIMPORT_RECUR_3_1                       0.5  	//  --
SCHEMAIMPORT_ENDING                          1  	// ===> Termination Syntax.

STRINGLITERAL_SYNTAX_1                       1          //  SingleQuoteLiteral
STRINGLITERAL_SYNTAX_2                       1          //  DoubleQuoteLiteral
STRINGLITERAL_ENDING                         0         // ===> Termination Syntax.
 
EXPRCOMMENT_SYNTAX_1                         1          //  "{--" [^}]* "--}"
EXPRCOMMENT_RECUR_1_1                        0.5        //  --
EXPRCOMMENT_RECUR_1_1_MAX                    1          //  --
 
S_SYNTAX_1                                   1          //  " "+
S_RECUR_1_1                                  0.5        //  --
S_RECUR_1_1_MAX                              1          //  --
 
PREDEFINEDENTITYREF_SYNTAX_1                 1          //  "&" "lt" ";"
PREDEFINEDENTITYREF_SYNTAX_2                 1          //  "&" "gt" ";"
PREDEFINEDENTITYREF_SYNTAX_3                 1          //  "&" "amp" ";"
PREDEFINEDENTITYREF_SYNTAX_4                 1          //  "&" "quot" ";"
PREDEFINEDENTITYREF_SYNTAX_5                 1          //  "&" "apos" ";"
PREDEFINEDENTITYREF_ENDING                   0         // ===> Termination Syntax.

